import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class AccordionStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<AccordionStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<AccordionStyle>;
}
/**
 *
 * Accordion groups a collection of contents in tabs.
 *
 * [Live Demo](https://www.primeng.org/accordion/)
 *
 * @module accordionstyle
 *
 */
export declare enum AccordionClasses {
    /**
     * Class name of the root element
     */
    root = "p-accordion",
    /**
     * Class name of the content wrapper
     */
    contentwrapper = "p-accordioncontent",
    /**
     * Class name of the content
     */
    content = "p-accordioncontent-content",
    /**
     * Class name of the header
     */
    header = "p-accordionheader",
    /**
     * Class name of the toggle icon
     */
    toggleicon = "p-accordionheader-toggle-icon",
    /**
     * Class name of the panel
     */
    panel = "p-accordionpanel"
}
export interface AccordionStyle extends BaseStyle {
}
