import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class AutoCompleteStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => {
            'p-autocomplete p-component p-inputwrapper': boolean;
            'p-disabled': any;
            'p-focus': any;
            'p-inputwrapper-filled': any;
            'p-inputwrapper-focus': any;
            'p-autocomplete-open': any;
            'p-autocomplete-clearable': boolean;
            'p-autocomplete-fluid': any;
        };
        pcInput: string;
        inputMultiple: ({ instance }: {
            instance: any;
        }) => {
            'p-autocomplete-input-multiple': boolean;
            'p-variant-filled': boolean;
        };
        chipItem: ({ instance, i }: {
            instance: any;
            i: any;
        }) => (string | {
            'p-focus': boolean;
        })[];
        pcChip: string;
        chipIcon: string;
        inputChip: string;
        loader: string;
        dropdown: string;
        overlay: string;
        list: string;
        optionGroup: string;
        option: ({ instance, option, i, getItemOptions }: {
            instance: any;
            option: any;
            i: any;
            getItemOptions: any;
        }) => {
            'p-autocomplete-option': boolean;
            'p-autocomplete-option-selected': any;
            'p-focus': boolean;
            'p-disabled': any;
        };
        emptyMessage: string;
    };
    inlineStyles: {
        root: {
            position: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<AutoCompleteStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<AutoCompleteStyle>;
}
/**
 *
 * AutoComplete is an input component that provides real-time suggestions while being typed.
 *
 * [Live Demo](https://www.primeng.org/autocomplete/)
 *
 * @module autocompletestyle
 *
 */
export declare enum AutoCompleteClasses {
    /**
     * Class name of the root element
     */
    root = "p-autocomplete",
    /**
     * Class name of the input element
     */
    pcInput = "p-autocomplete-input",
    /**
     * Class name of the input multiple element
     */
    inputMultiple = "p-autocomplete-input-multiple",
    /**
     * Class name of the chip item element
     */
    chipItem = "p-autocomplete-chip-item",
    /**
     * Class name of the chip element
     */
    pcChip = "p-autocomplete-chip",
    /**
     * Class name of the chip icon element
     */
    chipIcon = "p-autocomplete-chip-icon",
    /**
     * Class name of the input chip element
     */
    inputChip = "p-autocomplete-input-chip",
    /**
     * Class name of the loader element
     */
    loader = "p-autocomplete-loader",
    /**
     * Class name of the dropdown element
     */
    dropdown = "p-autocomplete-dropdown",
    /**
     * Class name of the panel element
     */
    panel = "p-autocomplete-overlay",
    /**
     * Class name of the list element
     */
    list = "p-autocomplete-list",
    /**
     * Class name of the option group element
     */
    optionGroup = "p-autocomplete-option-group",
    /**
     * Class name of the option element
     */
    option = "p-autocomplete-option",
    /**
     * Class name of the empty message element
     */
    emptyMessage = "p-autocomplete-empty-message"
}
export interface AutoCompleteStyle extends BaseStyle {
}
