import { ChangeDetectorRef, ElementRef, Injector, Renderer2, SimpleChanges } from '@angular/core';
import { BaseStyle } from 'primeng/base';
import { PrimeNG } from 'primeng/config';
import { BaseComponentStyle } from './style/basecomponentstyle';
import * as i0 from "@angular/core";
export declare class BaseComponent {
    document: Document;
    platformId: any;
    el: ElementRef;
    readonly injector: Injector;
    readonly cd: ChangeDetectorRef;
    renderer: Renderer2;
    config: PrimeNG;
    baseComponentStyle: BaseComponentStyle;
    baseStyle: BaseStyle;
    scopedStyleEl: any;
    rootEl: any;
    dt: Object | undefined;
    get styleOptions(): {
        nonce: string;
    };
    get _name(): string;
    get componentStyle(): any;
    attrSelector: string;
    _getHostInstance(instance: any): any;
    _getOptionValue(options: any, key?: string, params?: {}): any;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    _loadStyles(): void;
    _loadCoreStyles(): void;
    _loadThemeStyles(): void;
    _loadScopedThemeStyles(preset: any): void;
    _unloadScopedThemeStyles(): void;
    _themeChangeListener(callback?: () => void): void;
    cx(arg: string, rest?: string): string;
    sx(arg: string): string;
    get parent(): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<BaseComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BaseComponent, never, never, { "dt": { "alias": "dt"; "required": false; }; }, {}, never, never, true, never>;
}
