import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ButtonStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance, props }: {
            instance: any;
            props: any;
        }) => (string | {
            [x: string]: any;
            'p-button-icon-only': boolean;
            'p-button-vertical': any;
            'p-button-loading': any;
            'p-button-link': any;
            'p-button-raised': any;
            'p-button-rounded': any;
            'p-button-text': any;
            'p-button-outlined': any;
            'p-button-sm': boolean;
            'p-button-lg': boolean;
            'p-button-plain': any;
            'p-button-fluid': any;
        })[];
        loadingIcon: string;
        icon: ({ props }: {
            props: any;
        }) => (string | {
            [x: string]: any;
        })[];
        label: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ButtonStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ButtonStyle>;
}
/**
 *
 * Button is an extension to standard button element with icons and theming.
 *
 * [Live Demo](https://www.primeng.org/button/)
 *
 * @module buttonstyle
 *
 */
export declare enum ButtonClasses {
    /**
     * Class name of the root element
     */
    root = "p-button",
    /**
     * Class name of the loading icon element
     */
    loadingIcon = "p-button-loading-icon",
    /**
     * Class name of the icon element
     */
    icon = "p-button-icon",
    /**
     * Class name of the label element
     */
    label = "p-button-label"
}
export interface ButtonStyle extends BaseStyle {
}
