import { AfterContentInit, QueryList, TemplateRef } from '@angular/core';
import { BlockableUI, PrimeTemplate } from 'primeng/api';
import { BaseComponent } from 'primeng/basecomponent';
import { CardStyle } from './style/cardstyle';
import * as i0 from "@angular/core";
import * as i1 from "primeng/api";
/**
 * Card is a flexible container component.
 * @group Components
 */
export declare class Card extends BaseComponent implements AfterContentInit, BlockableUI {
    /**
     * Header of the card.
     * @group Props
     */
    header: string | undefined;
    /**
     * Subheader of the card.
     * @group Props
     */
    subheader: string | undefined;
    /**
     * Inline style of the element.
     * @group Props
     */
    set style(value: {
        [klass: string]: any;
    } | null | undefined);
    /**
     * Class of the element.
     * @group Props
     */
    styleClass: string | undefined;
    headerFacet: TemplateRef<any> | undefined;
    footerFacet: TemplateRef<any> | undefined;
    headerTemplate: TemplateRef<any> | undefined;
    titleTemplate: TemplateRef<any> | undefined;
    subtitleTemplate: TemplateRef<any> | undefined;
    contentTemplate: TemplateRef<any> | undefined;
    footerTemplate: TemplateRef<any> | undefined;
    _headerTemplate: TemplateRef<any> | undefined;
    _titleTemplate: TemplateRef<any> | undefined;
    _subtitleTemplate: TemplateRef<any> | undefined;
    _contentTemplate: TemplateRef<any> | undefined;
    _footerTemplate: TemplateRef<any> | undefined;
    _style: import("@angular/core").WritableSignal<{
        [klass: string]: any;
    }>;
    _componentStyle: CardStyle;
    getBlockableElement(): HTMLElement;
    templates: QueryList<PrimeTemplate> | undefined;
    ngAfterContentInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<Card, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<Card, "p-card", never, { "header": { "alias": "header"; "required": false; }; "subheader": { "alias": "subheader"; "required": false; }; "style": { "alias": "style"; "required": false; }; "styleClass": { "alias": "styleClass"; "required": false; }; }, {}, ["headerFacet", "footerFacet", "headerTemplate", "titleTemplate", "subtitleTemplate", "contentTemplate", "footerTemplate", "templates"], ["p-header", "*", "p-footer"], true, never>;
}
export declare class CardModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<CardModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<CardModule, never, [typeof Card, typeof i1.SharedModule], [typeof Card, typeof i1.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<CardModule>;
}
