import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class CarouselStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-carousel-vertical': any;
            'p-carousel-horizontal': boolean;
        })[];
        header: string;
        contentContainer: string;
        content: string;
        pcPrevButton: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-disabled': any;
        })[];
        viewport: string;
        itemList: string;
        itemClone: ({ index, value, totalShiftedItems, d_numVisible }: {
            index: any;
            value: any;
            totalShiftedItems: any;
            d_numVisible: any;
        }) => (string | {
            'p-carousel-item-active': boolean;
            'p-carousel-item-start': boolean;
            'p-carousel-item-end': boolean;
        })[];
        item: ({ instance, index }: {
            instance: any;
            index: any;
        }) => (string | {
            'p-carousel-item-active': boolean;
            'p-carousel-item-start': boolean;
            'p-carousel-item-end': boolean;
        })[];
        pcNextButton: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-disabled': any;
        })[];
        indicatorList: string;
        indicator: ({ instance, index }: {
            instance: any;
            index: any;
        }) => (string | {
            'p-carousel-indicator-active': boolean;
        })[];
        indicatorButton: string;
        footer: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<CarouselStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<CarouselStyle>;
}
/**
 *
 * Carousel is a content slider featuring various customization options.
 *
 * [Live Demo](https://www.primeng.org/carousel/)
 *
 * @module carouselstyle
 *
 */
export declare enum CarouselClasses {
    /**
     * Class name of the root element
     */
    root = "p-carousel",
    /**
     * Class name of the header element
     */
    header = "p-carousel-header",
    /**
     * Class name of the content container element
     */
    contentContainer = "p-carousel-content-container",
    /**
     * Class name of the content element
     */
    content = "p-carousel-content",
    /**
     * Class name of the previous button element
     */
    pcPrevButton = "p-carousel-prev-button",
    /**
     * Class name of the viewport element
     */
    viewport = "p-carousel-viewport",
    /**
     * Class name of the item list element
     */
    itemList = "p-carousel-item-list",
    /**
     * Class name of the item clone element
     */
    itemClone = "p-carousel-item-clone",
    /**
     * Class name of the item element
     */
    item = "p-carousel-item",
    /**
     * Class name of the next button element
     */
    pcNextButton = "p-carousel-next-button",
    /**
     * Class name of the indicator list element
     */
    indicatorList = "p-carousel-indicator-list",
    /**
     * Class name of the indicator element
     */
    indicator = "p-carousel-indicator",
    /**
     * Class name of the indicator button element
     */
    indicatorButton = "p-carousel-indicator-button",
    /**
     * Class name of the footer element
     */
    footer = "p-carousel-footer"
}
export interface CarouselStyle extends BaseStyle {
}
