import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class CascadeSelectStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance, props }: {
            instance: any;
            props: any;
        }) => (string | {
            'p-cascadeselect-mobile': any;
            'p-disabled': any;
            'p-invalid': any;
            'p-variant-filled': boolean;
            'p-focus': any;
            'p-inputwrapper-filled': any;
            'p-inputwrapper-focus': any;
            'p-cascadeselect-open': any;
            'p-cascadeselect-fluid': any;
            'p-cascadeselect-sm p-inputfield-sm': boolean;
            'p-cascadeselect-lg p-inputfield-lg': boolean;
        })[];
        label: ({ instance, props }: {
            instance: any;
            props: any;
        }) => (string | {
            'p-placeholder': boolean;
            'p-cascadeselect-label-empty': boolean;
        })[];
        dropdown: string;
        loadingIcon: string;
        dropdownIcon: string;
        overlay: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-cascadeselect-mobile-active': any;
        })[];
        listContainer: string;
        list: string;
        option: ({ instance, processedOption }: {
            instance: any;
            processedOption: any;
        }) => (string | {
            'p-cascadeselect-option-active': any;
            'p-cascadeselect-option-selected': any;
            'p-focus': any;
            'p-disabled': any;
        })[];
        optionContent: string;
        optionText: string;
        groupIcon: string;
        optionList: string;
    };
    inlineStyles: {
        root: ({ props }: {
            props: any;
        }) => {
            position: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<CascadeSelectStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<CascadeSelectStyle>;
}
/**
 *
 * CascadeSelect is a form component to select a value from a nested structure of options.
 *
 * [Live Demo](https://www.primeng.org/cascadeselect/)
 *
 * @module cascadeselectstyle
 *
 */
export declare enum CascadeSelectClasses {
    /**
     * Class name of the root element
     */
    root = "p-cascadeselect",
    /**
     * Class name of the label element
     */
    label = "p-cascadeselect-label",
    /**
     * Class name of the dropdown element
     */
    dropdown = "p-cascadeselect-dropdown",
    /**
     * Class name of the loading icon element
     */
    loadingIcon = "p-cascadeselect-loading-icon",
    /**
     * Class name of the dropdown icon element
     */
    dropdownIcon = "p-cascadeselect-dropdown-icon",
    /**
     * Class name of the overlay element
     */
    overlay = "p-cascadeselect-overlay",
    /**
     * Class name of the list container element
     */
    listContainer = "p-cascadeselect-list-container",
    /**
     * Class name of the list element
     */
    list = "p-cascadeselect-list",
    /**
     * Class name of the item element
     */
    item = "p-cascadeselect-item",
    /**
     * Class name of the item content element
     */
    itemContent = "p-cascadeselect-item-content",
    /**
     * Class name of the item text element
     */
    itemText = "p-cascadeselect-item-text",
    /**
     * Class name of the group icon element
     */
    groupIcon = "p-cascadeselect-group-icon",
    /**
     * Class name of the item list element
     */
    itemList = "p-cascadeselect-item-list"
}
export interface CascadeSelectStyle extends BaseStyle {
}
