import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class CheckboxStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance, props }: {
            instance: any;
            props: any;
        }) => (string | {
            'p-checkbox-checked': any;
            'p-disabled': any;
            'p-invalid': any;
            'p-variant-filled': boolean;
        })[];
        box: string;
        input: string;
        icon: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<CheckboxStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<CheckboxStyle>;
}
/**
 *
 * Checkbox is an extension to standard checkbox element with theming.
 *
 * [Live Demo](https://www.primeng.org/checkbox/)
 *
 * @module checkboxstyle
 *
 */
export declare enum CheckboxClasses {
    /**
     * Class name of the root element
     */
    root = "p-checkbox",
    /**
     * Class name of the box element
     */
    box = "p-checkbox-box",
    /**
     * Class name of the input element
     */
    input = "p-checkbox-input",
    /**
     * Class name of the icon element
     */
    icon = "p-checkbox-icon"
}
export interface CheckboxStyle extends BaseStyle {
}
