import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ChipStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
        image: string;
        icon: string;
        label: string;
        removeIcon: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ChipStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ChipStyle>;
}
/**
 *
 * Chip represents people using icons, labels and images.
 *
 * [Live Demo](https://www.primeng.org/chip)
 *
 * @module chipstyle
 *
 */
export declare enum ChipClasses {
    /**
     * Class name of the root element
     */
    root = "p-chip",
    /**
     * Class name of the image element
     */
    image = "p-chip-image",
    /**
     * Class name of the icon element
     */
    icon = "p-chip-icon",
    /**
     * Class name of the label element
     */
    label = "p-chip-label",
    /**
     * Class name of the remove icon element
     */
    removeIcon = "p-chip-remove-icon"
}
export interface ChipStyle extends BaseStyle {
}
