import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ColorPickerStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
        preview: ({ props }: {
            props: any;
        }) => (string | {
            'p-disabled': any;
        })[];
        panel: ({ props }: {
            props: any;
        }) => (string | {
            'p-colorpicker-panel-inline': any;
            'p-disabled': any;
        })[];
        content: string;
        colorSelector: string;
        colorBackground: string;
        colorHandle: string;
        hue: string;
        hueHandle: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ColorPickerStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ColorPickerStyle>;
}
/**
 *
 * ColorPicker groups a collection of contents in tabs.
 *
 * [Live Demo](https://www.primeng.org/colorpicker/)
 *
 * @module colorpickerstyle
 *
 */
export declare enum ColorPickerClasses {
    /**
     * Class name of the root element
     */
    root = "p-colorpicker",
    /**
     * Class name of the preview element
     */
    preview = "p-colorpicker-preview",
    /**
     * Class name of the panel element
     */
    panel = "p-colorpicker-panel",
    /**
     * Class name of the color selector element
     */
    colorSelector = "p-colorpicker-color-selector",
    /**
     * Class name of the color background element
     */
    colorBackground = "p-colorpicker-color-background",
    /**
     * Class name of the color handle element
     */
    colorHandle = "p-colorpicker-color-handle",
    /**
     * Class name of the hue element
     */
    hue = "p-colorpicker-hue",
    /**
     * Class name of the hue handle element
     */
    hueHandle = "p-colorpicker-hue-handle"
}
export interface ColorPickerStyle extends BaseStyle {
}
