import { OverlayOptions, Translation } from 'primeng/api';
import { ThemeConfigType, ThemeProvider } from './themeprovider';
import * as i0 from "@angular/core";
export type ZIndex = {
    modal: number;
    overlay: number;
    menu: number;
    tooltip: number;
};
export type PrimeNGConfigType = {
    ripple?: boolean;
    inputStyle?: 'outlined' | 'filled';
    csp?: {
        nonce: string | undefined;
    };
    overlayOptions?: OverlayOptions;
    translation?: Translation;
} & ThemeConfigType;
export declare class PrimeNG extends ThemeProvider {
    ripple: import("@angular/core").WritableSignal<boolean>;
    platformId: any;
    inputStyle: import("@angular/core").WritableSignal<"outlined" | "filled">;
    inputVariant: import("@angular/core").WritableSignal<"outlined" | "filled">;
    overlayOptions: OverlayOptions;
    csp: import("@angular/core").WritableSignal<{
        nonce: string | undefined;
    }>;
    filterMatchModeOptions: {
        text: string[];
        numeric: string[];
        date: string[];
    };
    translation: Translation;
    zIndex: ZIndex;
    private translationSource;
    translationObserver: import("rxjs").Observable<any>;
    getTranslation(key: string): any;
    setTranslation(value: Translation): void;
    setConfig(config: PrimeNGConfigType): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PrimeNG, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PrimeNG>;
}
