import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ConfirmDialogStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
        icon: string;
        message: string;
        pcRejectButton: string;
        pcAcceptButton: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ConfirmDialogStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ConfirmDialogStyle>;
}
/**
 *
 * ConfirmDialog uses a Dialog UI with confirmDialog method or <ConfirmDialog> tag.
 *
 * [Live Demo](https://www.primeng.org/confirmdialog)
 *
 * @module confirmdialogstyle
 *
 */
export declare enum ConfirmDialogClasses {
    /**
     * Class name of the root element
     */
    root = "p-confirmdialog",
    /**
     * Class name of the icon element
     */
    icon = "p-confirmdialog-icon",
    /**
     * Class name of the message element
     */
    message = "p-confirmdialog-message",
    /**
     * Class name of the reject button element
     */
    pcRejectButton = "p-confirmdialog-reject-button",
    /**
     * Class name of the accept button element
     */
    pcAcceptButton = "p-confirmdialog-accept-button"
}
export interface ConfirmDialogStyle extends BaseStyle {
}
