import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ContextMenuStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
        rootList: string;
        item: ({ instance, processedItem }: {
            instance: any;
            processedItem: any;
        }) => (string | {
            'p-contextmenu-item-active': any;
            'p-focus': any;
            'p-disabled': any;
        })[];
        itemContent: string;
        itemLink: string;
        itemIcon: string;
        itemLabel: string;
        submenuIcon: string;
        submenu: string;
        separator: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ContextMenuStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ContextMenuStyle>;
}
/**
 *
 * ContextMenu displays an overlay menu on right click of its target. Note that components like DataTable has special integration with ContextMenu.
 * Refer to documentation of the individual documentation of the with context menu support.
 *
 * [Live Demo](https://www.primeng.org/contextmenu/)
 *
 * @module contextmenustyle
 *
 */
export declare enum ContextMenuClasses {
    /**
     * Class name of the root element
     */
    root = "p-contextmenu",
    /**
     * Class name of the root list element
     */
    rootList = "p-contextmenu-root-list",
    /**
     * Class name of the item element
     */
    item = "p-contextmenu-item",
    /**
     * Class name of the item content element
     */
    itemContent = "p-contextmenu-item-content",
    /**
     * Class name of the item link element
     */
    itemLink = "p-contextmenu-item-link",
    /**
     * Class name of the item icon element
     */
    itemIcon = "p-contextmenu-item-icon",
    /**
     * Class name of the item label element
     */
    itemLabel = "p-contextmenu-item-label",
    /**
     * Class name of the submenu icon element
     */
    submenuIcon = "p-contextmenu-submenu-icon",
    /**
     * Class name of the submenu element
     */
    submenu = "p-contextmenu-submenu",
    /**
     * Class name of the separator element
     */
    separator = "p-contextmenu-separator"
}
export interface ContextMenuStyle extends BaseStyle {
}
