import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class DataViewStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-dataview-list': boolean;
            'p-dataview-grid': boolean;
        })[];
        header: string;
        pcPaginator: ({ position }: {
            position: any;
        }) => string;
        content: string;
        emptyMessage: string;
        footer: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<DataViewStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DataViewStyle>;
}
/**
 *
 * DataView displays data in grid or list layout with pagination and sorting features.
 *
 * [Live Demo](https://www.primeng.org/dataview/)
 *
 * @module dataviewstyle
 *
 */
export declare enum DataViewClasses {
    /**
     * Class name of the root element
     */
    root = "p-dataview",
    /**
     * Class name of the header element
     */
    header = "p-dataview-header",
    /**
     * Class name of the paginator element
     */
    pcPaginator = "p-dataview-paginator-[position]",
    /**
     * Class name of the content element
     */
    content = "p-dataview-content",
    /**
     * Class name of the empty message element
     */
    emptyMessage = "p-dataview-empty-message",// TODO: remove?
    /**
     * Class name of the footer element
     */
    footer = "p-dataview-footer"
}
export interface DataViewStyle extends BaseStyle {
}
