import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class DialogStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        mask: ({ instance }: {
            instance: any;
        }) => {
            [x: string]: any;
            'p-dialog-mask': boolean;
            'p-overlay-mask p-overlay-mask-enter': any;
        };
        root: ({ instance }: {
            instance: any;
        }) => {
            'p-dialog p-component': boolean;
            'p-dialog-maximized': any;
        };
        header: string;
        title: string;
        resizeHandle: string;
        headerActions: string;
        pcMaximizeButton: string;
        pcCloseButton: string;
        content: string;
        footer: string;
    };
    inlineStyles: {
        mask: ({ instance }: {
            instance: any;
        }) => {
            position: string;
            height: string;
            width: string;
            left: number;
            top: number;
            display: string;
            justifyContent: string;
            alignItems: string;
            pointerEvents: string;
        };
        root: {
            display: string;
            flexDirection: string;
            pointerEvents: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<DialogStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DialogStyle>;
}
/**
 *
 * Dialog is a container to display content in an overlay window.
 *
 * [Live Demo](https://www.primeng.org/dialog)
 *
 * @module dialogstyle
 *
 */
export declare enum DialogClasses {
    /**
     * Class name of the mask element
     */
    mask = "p-dialog-mask",
    /**
     * Class name of the root element
     */
    root = "p-dialog",
    /**
     * Class name of the header element
     */
    header = "p-dialog-header",
    /**
     * Class name of the title element
     */
    title = "p-dialog-title",
    /**
     * Class name of the header actions element
     */
    headerActions = "p-dialog-header-actions",
    /**
     * Class name of the maximize button element
     */
    pcMaximizeButton = "p-dialog-maximize-button",
    /**
     * Class name of the close button element
     */
    pcCloseButton = "p-dialog-close-button",
    /**
     * Class name of the content element
     */
    content = "p-dialog-content",
    /**
     * Class name of the footer element
     */
    footer = "p-dialog-footer"
}
export interface DialogStyle extends BaseStyle {
}
