import { BaseComponent } from 'primeng/basecomponent';
import { DividerStyle } from './style/dividerstyle';
import * as i0 from "@angular/core";
/**
 * Divider is used to separate contents.
 * @group Components
 */
export declare class Divider extends BaseComponent {
    /**
     * Inline style of the component.
     * @group Props
     */
    style: {
        [klass: string]: any;
    } | null | undefined;
    /**
     * Style class of the component.
     * @group Props
     */
    styleClass: string | undefined;
    /**
     * Specifies the orientation.
     * @group Props
     */
    layout: 'horizontal' | 'vertical' | undefined;
    /**
     * Border style type.
     * @group Props
     */
    type: 'solid' | 'dashed' | 'dotted' | undefined;
    /**
     * Alignment of the content.
     * @group Props
     */
    align: 'left' | 'center' | 'right' | 'top' | 'bottom' | undefined;
    _componentStyle: DividerStyle;
    get hostClass(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<Divider, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<Divider, "p-divider", never, { "style": { "alias": "style"; "required": false; }; "styleClass": { "alias": "styleClass"; "required": false; }; "layout": { "alias": "layout"; "required": false; }; "type": { "alias": "type"; "required": false; }; "align": { "alias": "align"; "required": false; }; }, {}, never, ["*"], true, never>;
}
export declare class DividerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DividerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DividerModule, never, [typeof Divider], [typeof Divider]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DividerModule>;
}
