import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class DividerStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-divider-left': boolean;
            'p-divider-center'?: undefined;
            'p-divider-right'?: undefined;
            'p-divider-top'?: undefined;
            'p-divider-bottom'?: undefined;
        } | {
            'p-divider-center': boolean;
            'p-divider-left'?: undefined;
            'p-divider-right'?: undefined;
            'p-divider-top'?: undefined;
            'p-divider-bottom'?: undefined;
        } | {
            'p-divider-right': boolean;
            'p-divider-left'?: undefined;
            'p-divider-center'?: undefined;
            'p-divider-top'?: undefined;
            'p-divider-bottom'?: undefined;
        } | {
            'p-divider-top': boolean;
            'p-divider-left'?: undefined;
            'p-divider-center'?: undefined;
            'p-divider-right'?: undefined;
            'p-divider-bottom'?: undefined;
        } | {
            'p-divider-bottom': boolean;
            'p-divider-left'?: undefined;
            'p-divider-center'?: undefined;
            'p-divider-right'?: undefined;
            'p-divider-top'?: undefined;
        })[];
        content: string;
    };
    inlineStyles: {
        root: ({ props }: {
            props: any;
        }) => {
            justifyContent: string;
            alignItems: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<DividerStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DividerStyle>;
}
/**
 *
 * Divider is used to separate contents.
 *
 * [Live Demo](https://primeng.org/divider)
 *
 * @module dividerstyle
 *
 */
export declare enum DividerClasses {
    /**
     * Class name of the root element
     */
    root = "p-divider",
    /**
     * Class name of the content element
     */
    content = "p-divider-content"
}
export interface DividerStyle extends BaseStyle {
}
