import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class DockStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance, props }: {
            instance: any;
            props: any;
        }) => (string | {
            'p-dock-mobile': any;
        })[];
        listContainer: string;
        list: string;
        item: ({ instance, processedItem, id }: {
            instance: any;
            processedItem: any;
            id: any;
        }) => (string | {
            'p-focus': any;
            'p-disabled': any;
        })[];
        itemContent: string;
        itemLink: string;
        itemIcon: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<DockStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DockStyle>;
}
/**
 *
 * Dock is a navigation component consisting of menuitems.
 *
 * [Live Demo](https://www.primeng.org/dock/)
 *
 * @module dockstyle
 *
 */
export declare enum DockClasses {
    /**
     * Class name of the root element
     */
    root = "p-dock",
    /**
     * Class name of the list container element
     */
    listContainer = "p-dock-list-container",
    /**
     * Class name of the list element
     */
    list = "p-dock-list",
    /**
     * Class name of the item element
     */
    item = "p-dock-item",
    /**
     * Class name of the item content element
     */
    itemContent = "p-dock-item-content",
    /**
     * Class name of the item link element
     */
    itemLink = "p-dock-item-link",
    /**
     * Class name of the item icon element
     */
    itemIcon = "p-dock-item-icon"
}
export interface DockStyle extends BaseStyle {
}
