import { BaseStyle } from 'primeng/base';
/**
 *
 * Dropdown also known as Select, is used to choose an item from a collection of options.
 *
 * [Live Demo](https://www.primeng.org/select/)
 *
 * @module dropdownstyle
 *
 */
import type { SelectStyle } from 'primeng/select';
import * as i0 from "@angular/core";
export declare class DropdownStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-disabled': any;
            'p-variant-filled': boolean;
            'p-focus': any;
            'p-inputwrapper-filled': boolean;
            'p-inputwrapper-focus': any;
            'p-select-open': any;
            'p-select-fluid': any;
            'p-select-sm p-inputfield-sm': boolean;
            'p-select-lg p-inputfield-lg': boolean;
        })[];
        label: ({ instance, props }: {
            instance: any;
            props: any;
        }) => (string | {
            'p-placeholder': boolean;
            'p-select-label-empty': boolean;
        })[];
        clearIcon: string;
        dropdown: string;
        loadingicon: string;
        dropdownIcon: string;
        overlay: string;
        header: string;
        pcFilter: string;
        listContainer: string;
        list: string;
        optionGroup: string;
        optionGroupLabel: string;
        option: ({ instance, props, state, option, focusedOption }: {
            instance: any;
            props: any;
            state: any;
            option: any;
            focusedOption: any;
        }) => (string | {
            'p-select-option-selected': any;
            'p-focus': boolean;
            'p-disabled': any;
        })[];
        optionLabel: string;
        optionCheckIcon: string;
        optionBlankIcon: string;
        emptyMessage: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<DropdownStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DropdownStyle>;
}
export declare enum DropdownClasses {
}
export interface DropdownStyle extends SelectStyle {
}
