import { AnimationEvent } from '@angular/animations';
import { AfterViewInit, ComponentRef, ElementRef, NgZone, OnDestroy, Renderer2, Type } from '@angular/core';
import { BaseComponent } from 'primeng/basecomponent';
import { Nullable, VoidListener } from 'primeng/ts-helpers';
import { DynamicDialogConfig } from './dynamicdialog-config';
import { DynamicDialogRef } from './dynamicdialog-ref';
import { DynamicDialogContent } from './dynamicdialogcontent';
import { DynamicDialogStyle } from './style/dynamicdialogstyle';
import * as i0 from "@angular/core";
import * as i1 from "primeng/api";
export declare class DynamicDialogComponent extends BaseComponent implements AfterViewInit, OnDestroy {
    renderer: Renderer2;
    ddconfig: DynamicDialogConfig;
    private dialogRef;
    zone: NgZone;
    private parentDialog;
    visible: boolean;
    componentRef: Nullable<ComponentRef<any>>;
    mask: Nullable<HTMLDivElement>;
    resizing: boolean | undefined;
    dragging: boolean | undefined;
    maximized: boolean | undefined;
    _style: any;
    originalStyle: any;
    lastPageX: number | undefined;
    lastPageY: number | undefined;
    ariaLabelledBy: string | undefined;
    id: string;
    styleElement: any;
    insertionPoint: Nullable<DynamicDialogContent>;
    maskViewChild: Nullable<ElementRef>;
    contentViewChild: Nullable<ElementRef>;
    footerViewChild: Nullable<ElementRef>;
    headerViewChild: Nullable<ElementRef>;
    childComponentType: Nullable<Type<any>>;
    container: Nullable<HTMLDivElement>;
    wrapper: Nullable<HTMLElement>;
    documentKeydownListener: VoidListener;
    documentEscapeListener: VoidListener;
    maskClickListener: VoidListener;
    transformOptions: string;
    documentResizeListener: VoidListener;
    documentResizeEndListener: VoidListener;
    documentDragListener: VoidListener;
    documentDragEndListener: VoidListener;
    _componentStyle: DynamicDialogStyle;
    get minX(): number;
    get minY(): number;
    get keepInViewport(): boolean;
    get maximizable(): boolean;
    get maximizeIcon(): string;
    get minimizeIcon(): string;
    get closable(): boolean;
    get style(): any;
    get position(): string;
    get closeAriaLabel(): string;
    set style(value: any);
    get parent(): Element;
    get parentContent(): any;
    get header(): string;
    get data(): any;
    get breakpoints(): any;
    get footerTemplate(): Type<any>;
    get headerTemplate(): Type<any>;
    get contentTemplate(): Type<any>;
    get minimizeIconTemplate(): Type<any>;
    get maximizeIconTemplate(): Type<any>;
    get closeIconTemplate(): Type<any>;
    get maskClass(): {
        [x: string]: string | boolean;
        'p-dialog-mask': boolean;
        'p-overlay-mask p-overlay-mask-enter': boolean;
    };
    get dialogId(): string;
    constructor(renderer: Renderer2, ddconfig: DynamicDialogConfig, dialogRef: DynamicDialogRef, zone: NgZone, parentDialog: DynamicDialogComponent);
    ngOnInit(): void;
    createStyle(): void;
    destroyStyle(): void;
    ngAfterViewInit(): void;
    getAriaLabelledBy(): string;
    loadChildComponent(componentType: Type<any>): void;
    moveOnTop(): void;
    onAnimationStart(event: AnimationEvent): void;
    onAnimationEnd(event: AnimationEvent): void;
    onContainerDestroy(): void;
    close(): void;
    hide(): void;
    enableModality(): void;
    disableModality(): void;
    focus(focusParentElement?: any): void;
    maximize(): void;
    initResize(event: MouseEvent): void;
    onResize(event: MouseEvent): void;
    resizeEnd(event: MouseEvent): void;
    initDrag(event: MouseEvent): void;
    onDrag(event: MouseEvent): void;
    endDrag(event: MouseEvent): void;
    resetPosition(): void;
    bindDocumentDragListener(): void;
    bindDocumentDragEndListener(): void;
    unbindDocumentDragEndListener(): void;
    unbindDocumentDragListener(): void;
    bindDocumentResizeListeners(): void;
    unbindDocumentResizeListeners(): void;
    bindGlobalListeners(): void;
    unbindGlobalListeners(): void;
    bindDocumentEscapeListener(): void;
    unbindDocumentEscapeListener(): void;
    unbindMaskClickListener(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicDialogComponent, [null, null, null, null, { optional: true; skipSelf: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DynamicDialogComponent, "p-dynamicDialog, p-dynamicdialog, p-dynamic-dialog", never, {}, {}, never, never, true, never>;
}
export declare class DynamicDialog {
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicDialog, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DynamicDialog, never, [typeof DynamicDialogComponent, typeof i1.SharedModule], [typeof DynamicDialogComponent, typeof i1.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DynamicDialog>;
}
