import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class FieldsetStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-fieldset-toggleable': any;
        })[];
        legend: string;
        legendLabel: string;
        toggleButton: string;
        toggleIcon: string;
        contentContainer: string;
        content: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<FieldsetStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FieldsetStyle>;
}
/**
 *
 * Fieldset is a grouping component with the optional content toggle feature.
 *
 * [Live Demo](https://www.primeng.org/fieldset/)
 *
 * @module fieldsetstyle
 *
 */
export declare enum FieldsetClasses {
    /**
     * Class name of the root element
     */
    root = "p-fieldset",
    /**
     * Class name of the legend element
     */
    legend = "p-fieldset-legend",
    /**
     * Class name of the legend label element
     */
    legendLabel = "p-fieldset-legend-label",
    /**
     * Class name of the toggle icon element
     */
    toggleIcon = "p-fieldset-toggle-icon",
    /**
     * Class name of the content container element
     */
    contentContainer = "p-fieldset-content-container",
    /**
     * Class name of the content element
     */
    content = "p-fieldset-content"
}
export interface FieldsetStyle extends BaseStyle {
}
