import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class FileUploadStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => string;
        header: string;
        pcChooseButton: string;
        pcUploadButton: string;
        pcCancelButton: string;
        content: string;
        fileList: string;
        file: string;
        fileThumbnail: string;
        fileInfo: string;
        fileName: string;
        fileSize: string;
        pcFileBadge: string;
        fileActions: string;
        pcFileRemoveButton: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<FileUploadStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FileUploadStyle>;
}
/**
 *
 * FileUpload is an advanced uploader with dragdrop support, multi file uploads, auto uploading, progress tracking and validations.
 *
 * [Live Demo](https://www.primeng.org/fileupload/)
 *
 * @module fileuploadstyle
 *
 */
export declare enum FileUploadClasses {
    /**
     * Class name of the root element
     */
    root = "p-fileupload",
    /**
     * Class name of the header element
     */
    header = "p-fileupload-header",
    /**
     * Class name of the choose button element
     */
    pcChooseButton = "p-fileupload-choose-button",
    /**
     * Class name of the upload button element
     */
    pcUploadButton = "p-fileupload-upload-button",
    /**
     * Class name of the cancel button element
     */
    pcCancelButton = "p-fileupload-cancel-button",
    /**
     * Class name of the content element
     */
    content = "p-fileupload-content",
    /**
     * Class name of the file list element
     */
    fileList = "p-fileupload-file-list",
    /**
     * Class name of the file element
     */
    file = "p-fileupload-file",
    /**
     * Class name of the file thumbnail element
     */
    fileThumbnail = "p-fileupload-file-thumbnail",
    /**
     * Class name of the file info element
     */
    fileInfo = "p-fileupload-file-info",
    /**
     * Class name of the file name element
     */
    fileName = "p-fileupload-file-name",
    /**
     * Class name of the file size element
     */
    fileSize = "p-fileupload-file-size",
    /**
     * Class name of the file badge element
     */
    pcFileBadge = "p-fileupload-file-badge",
    /**
     * Class name of the file actions element
     */
    fileActions = "p-fileupload-file-actions",
    /**
     * Class name of the file remove button element
     */
    pcFileRemoveButton = "p-fileupload-file-remove-button"
}
export interface FileUploadStyle extends BaseStyle {
}
