import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ImageStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-image-preview': any;
        })[];
        previewMask: string;
        previewIcon: string;
        mask: string;
        toolbar: string;
        rotateRightButton: string;
        rotateLeftButton: string;
        zoomOutButton: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-disabled': any;
        })[];
        zoomInButton: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-disabled': any;
        })[];
        closeButton: string;
        original: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ImageStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ImageStyle>;
}
/**
 *
 * Displays an image with preview and tranformation options. For multiple image, see Galleria.
 *
 * [Live Demo](https://www.primeng.org/image/)
 *
 * @module imagestyle
 *
 */
export declare enum ImageClasses {
    /**
     * Class name of the root element
     */
    root = "p-image",
    /**
     * Class name of the preview mask element
     */
    previewMask = "p-image-preview-mask",
    /**
     * Class name of the preview icon element
     */
    previewIcon = "p-image-preview-icon",
    /**
     * Class name of the mask element
     */
    mask = "p-image-mask",
    /**
     * Class name of the toolbar element
     */
    toolbar = "p-image-toolbar",
    /**
     * Class name of the rotate right button element
     */
    rotateRightButton = "p-image-rotate-right-button",
    /**
     * Class name of the rotate left button element
     */
    rotateLeftButton = "p-image-rotate-left-button",
    /**
     * Class name of the zoom out button element
     */
    zoomOutButton = "p-image-zoom-out-button",
    /**
     * Class name of the zoom in button element
     */
    zoomInButton = "p-image-zoom-in-button",
    /**
     * Class name of the close button element
     */
    closeButton = "p-image-close-button",
    /**
     * Class name of the original element
     */
    original = "p-image-original"
}
export interface ImageStyle extends BaseStyle {
}
