import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class InplaceStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
        display: ({ props }: {
            props: any;
        }) => (string | {
            'p-disabled': any;
        })[];
        content: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<InplaceStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<InplaceStyle>;
}
/**
 *
 * Inplace provides an easy to do editing and display at the same time where clicking the output displays the actual content.
 *
 * [Live Demo](https://www.primeng.org/inplace)
 *
 * @module inplacestyle
 *
 */
export declare enum InplaceClasses {
    /**
     * Class name of the root element
     */
    root = "p-inplace",
    /**
     * Class name of the display element
     */
    display = "p-inplace-display",
    /**
     * Class name of the content element
     */
    content = "p-inplace-content"
}
export interface InplaceStyle extends BaseStyle {
}
