import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class InputNumberStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => {
            'p-inputnumber p-component p-inputwrapper': boolean;
            'p-inputwrapper-filled': any;
            'p-inputwrapper-focus': any;
            'p-inputnumber-stacked': boolean;
            'p-inputnumber-horizontal': boolean;
            'p-inputnumber-vertical': boolean;
            'p-inputnumber-fluid': any;
        };
        pcInput: string;
        buttonGroup: string;
        incrementButton: ({ instance }: {
            instance: any;
        }) => {
            'p-inputnumber-button p-inputnumber-increment-button': boolean;
            'p-disabled': any;
        };
        decrementButton: ({ instance }: {
            instance: any;
        }) => {
            'p-inputnumber-button p-inputnumber-decrement-button': boolean;
            'p-disabled': any;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<InputNumberStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<InputNumberStyle>;
}
/**
 *
 * InputNumber is an input component to provide numerical input.
 *
 * [Live Demo](https://www.primeng.org/inputnumber/)
 *
 * @module inputnumberstyle
 *
 */
export declare enum InputNumberClasses {
    /**
     * Class name of the root element
     */
    root = "p-inputnumber",
    /**
     * Class name of the input element
     */
    pcInput = "p-inputnumber-input",
    /**
     * Class name of the button group element
     */
    buttonGroup = "p-inputnumber-button-group",
    /**
     * Class name of the increment button element
     */
    incrementButton = "p-inputnumber-increment-button",
    /**
     * Class name of the decrement button element
     */
    decrementButton = "p-inputnumber-decrement-button"
}
export interface InputNumberStyle extends BaseStyle {
}
