import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class KnobStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-disabled': any;
        })[];
        range: string;
        value: string;
        text: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<KnobStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<KnobStyle>;
}
/**
 *
 * Knob is a form component to define number inputs with a dial.
 *
 * [Live Demo](https://www.primeng.org/knob/)
 *
 * @module knobstyle
 *
 */
export declare enum KnobClasses {
    /**
     * Class name of the root element
     */
    root = "p-knob",
    /**
     * Class name of the range element
     */
    range = "p-knob-range",
    /**
     * Class name of the value element
     */
    value = "p-knob-value",
    /**
     * Class name of the text element
     */
    text = "p-knob-text"
}
export interface KnobStyle extends BaseStyle {
}
