import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ListBoxStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-listbox-striped': any;
            'p-disabled': any;
            'p-invalid': any;
        })[];
        header: string;
        pcFilter: string;
        listContainer: string;
        list: string;
        optionGroup: string;
        option: ({ instance, props, option, index, getItemOptions }: {
            instance: any;
            props: any;
            option: any;
            index: any;
            getItemOptions: any;
        }) => (string | {
            'p-listbox-option-selected': any;
            'p-focus': boolean;
            'p-disabled': any;
        })[];
        optionCheckIcon: string;
        optionBlankIcon: string;
        emptyMessage: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ListBoxStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ListBoxStyle>;
}
/**
 *
 * ListBox is used to select one or more values from a list of items.
 *
 * [Live Demo](https://www.primeng.org/listbox/)
 *
 * @module listboxstyle
 *
 */
export declare enum ListboxClasses {
    /**
     * Class name of the root element
     */
    root = "p-listbox",
    /**
     * Class name of the header element
     */
    header = "p-listbox-header",
    /**
     * Class name of the filter element
     */
    pcFilter = "p-listbox-filter",
    /**
     * Class name of the list container element
     */
    listContainer = "p-listbox-list-container",
    /**
     * Class name of the list element
     */
    list = "p-listbox-list",
    /**
     * Class name of the option group element
     */
    optionGroup = "p-listbox-option-group",
    /**
     * Class name of the option element
     */
    option = "p-listbox-option",
    /**
     * Class name of the option check icon element
     */
    optionCheckIcon = "p-listbox-option-check-icon",
    /**
     * Class name of the option blank icon element
     */
    optionBlankIcon = "p-listbox-option-blank-icon",
    /**
     * Class name of the empty message element
     */
    emptyMessage = "p-listbox-empty-message"
}
export interface ListboxStyle extends BaseStyle {
}
