import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class MegaMenuStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-megamenu-mobile': any;
            'p-megamenu-mobile-active': any;
            'p-megamenu-horizontal': any;
            'p-megamenu-vertical': any;
        })[];
        start: string;
        button: string;
        rootList: string;
        submenuLabel: ({ instance, processedItem }: {
            instance: any;
            processedItem: any;
        }) => (string | {
            'p-disabled': any;
        })[];
        item: ({ instance, processedItem }: {
            instance: any;
            processedItem: any;
        }) => (string | {
            'p-megamenu-item-active': any;
            'p-focus': any;
            'p-disabled': any;
        })[];
        itemContent: string;
        itemLink: string;
        itemIcon: string;
        itemLabel: string;
        submenuIcon: string;
        overlay: string;
        grid: string;
        column: ({ instance, processedItem }: {
            instance: any;
            processedItem: any;
        }) => any;
        submenu: string;
        separator: string;
        end: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<MegaMenuStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MegaMenuStyle>;
}
/**
 *
 * MegaMenu is navigation component that displays submenus together.
 *
 * [Live Demo](https://www.primeng.org/megamenu/)
 *
 * @module megamenustyle
 *
 */
export declare enum MegaMenuClasses {
    /**
     * Class name of the root element
     */
    root = "p-megamenu",
    /**
     * Class name of the start element
     */
    start = "p-megamenu-start",
    /**
     * Class name of the button element
     */
    button = "p-megamenu-button",
    /**
     * Class name of the root list element
     */
    rootList = "p-megamenu-root-list",
    /**
     * Class name of the submenu item element
     */
    submenuItem = "p-megamenu-submenu-item",
    /**
     * Class name of the item element
     */
    item = "p-megamenu-item",
    /**
     * Class name of the item content element
     */
    itemContent = "p-megamenu-item-content",
    /**
     * Class name of the item link element
     */
    itemLink = "p-megamenu-item-link",
    /**
     * Class name of the item icon element
     */
    itemIcon = "p-megamenu-item-icon",
    /**
     * Class name of the item label element
     */
    itemLabel = "p-megamenu-item-label",
    /**
     * Class name of the submenu icon element
     */
    submenuIcon = "p-megamenu-submenu-icon",
    /**
     * Class name of the panel element
     */
    panel = "p-megamenu-panel",
    /**
     * Class name of the grid element
     */
    grid = "p-megamenu-grid",
    /**
     * Class name of the submenu element
     */
    submenu = "p-megamenu-submenu",
    /**
     * Class name of the submenu item label element
     */
    submenuItemLabel = "p-megamenu-submenu-item-label",
    /**
     * Class name of the separator element
     */
    separator = "p-megamenu-separator",
    /**
     * Class name of the end element
     */
    end = "p-megamenu-end"
}
export interface MegaMenuStyle extends BaseStyle {
}
