import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class MenuStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-menu-overlay': any;
        })[];
        start: string;
        list: string;
        submenuLabel: string;
        separator: string;
        end: string;
        item: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-focus': boolean;
            'p-disabled': any;
        })[];
        itemContent: string;
        itemLink: string;
        itemIcon: string;
        itemLabel: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<MenuStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MenuStyle>;
}
/**
 *
 * Menu is a navigation / command component that supports dynamic and static positioning.
 *
 * [Live Demo](https://www.primeng.org/menu/)
 *
 * @module menustyle
 *
 */
export declare enum MenuClasses {
    /**
     * Class name of the root element
     */
    root = "p-menu",
    /**
     * Class name of the start element
     */
    start = "p-menu-start",
    /**
     * Class name of the list element
     */
    list = "p-menu-list",
    /**
     * Class name of the submenu item element
     */
    submenuItem = "p-menu-submenu-item",
    /**
     * Class name of the separator element
     */
    separator = "p-menu-separator",
    /**
     * Class name of the end element
     */
    end = "p-menu-end",
    /**
     * Class name of the item element
     */
    item = "p-menu-item",
    /**
     * Class name of the item content element
     */
    itemContent = "p-menu-item-content",
    /**
     * Class name of the item link element
     */
    itemLink = "p-menu-item-link",
    /**
     * Class name of the item icon element
     */
    itemIcon = "p-menu-item-icon",
    /**
     * Class name of the item label element
     */
    itemLabel = "p-menu-item-label"
}
export interface MenuStyle extends BaseStyle {
}
