import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class MenuBarStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-menubar-mobile': any;
            'p-menubar-mobile-active': any;
        })[];
        start: string;
        button: string;
        rootList: string;
        item: ({ instance, processedItem }: {
            instance: any;
            processedItem: any;
        }) => (string | {
            'p-menubar-item-active': any;
            'p-focus': any;
            'p-disabled': any;
        })[];
        itemContent: string;
        itemLink: string;
        itemIcon: string;
        itemLabel: string;
        submenuIcon: string;
        submenu: string;
        separator: string;
        end: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<MenuBarStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MenuBarStyle>;
}
/**
 *
 * Menubar is a horizontal menu component.
 *
 * [Live Demo](https://www.primeng.org/menubar/)
 *
 * @module menubarstyle
 *
 */
export declare enum MenubarClasses {
    /**
     * Class name of the root element
     */
    root = "p-menubar",
    /**
     * Class name of the start element
     */
    start = "p-menubar-start",
    /**
     * Class name of the button element
     */
    button = "p-menubar-button",
    /**
     * Class name of the root list element
     */
    rootList = "p-menubar-root-list",
    /**
     * Class name of the item element
     */
    item = "p-menubar-item",
    /**
     * Class name of the item content element
     */
    itemContent = "p-menubar-item-content",
    /**
     * Class name of the item link element
     */
    itemLink = "p-menubar-item-link",
    /**
     * Class name of the item icon element
     */
    itemIcon = "p-menubar-item-icon",
    /**
     * Class name of the item label element
     */
    itemLabel = "p-menubar-item-label",
    /**
     * Class name of the submenu icon element
     */
    submenuIcon = "p-menubar-submenu-icon",
    /**
     * Class name of the submenu element
     */
    submenu = "p-menubar-submenu",
    /**
     * Class name of the separator element
     */
    separator = "p-menubar-separator",
    /**
     * Class name of the end element
     */
    end = "p-menubar-end"
}
export interface MenubarStyle extends BaseStyle {
}
