import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class MeterGroupStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-metergroup-horizontal': boolean;
            'p-metergroup-vertical': boolean;
        })[];
        meters: string;
        meter: string;
        labelList: ({ props }: {
            props: any;
        }) => (string | {
            'p-metergroup-label-list-vertical': boolean;
            'p-metergroup-label-list-horizontal': boolean;
        })[];
        label: string;
        labelIcon: string;
        labelMarker: string;
        labelText: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<MeterGroupStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MeterGroupStyle>;
}
/**
 *
 * MeterGroup is a group of process status indicators.
 *
 * [Live Demo](https://www.primeng.org/metergroup)
 *
 * @module metergroupstyle
 *
 */
export declare enum MeterGroupClasses {
    /**
     * Class name of the root element
     */
    root = "p-metergroup",
    /**
     * Class name of the meters element
     */
    meters = "p-metergroup-meters",
    /**
     * Class name of the meter element
     */
    meter = "p-metergroup-meter",
    /**
     * Class name of the label list element
     */
    labelList = "p-metergroup-label-list",
    /**
     * Class name of the label element
     */
    label = "p-metergroup-label",
    /**
     * Class name of the label icon element
     */
    labelIcon = "p-metergroup-label-icon",
    /**
     * Class name of the label marker element
     */
    labelMarker = "p-metergroup-label-marker",
    /**
     * Class name of the label text element
     */
    labelText = "p-metergroup-label-text"
}
export interface MeterGroupStyle extends BaseStyle {
}
