import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class PanelStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-panel-toggleable': any;
        })[];
        header: string;
        title: string;
        headerActions: string;
        pcToggleButton: string;
        contentContainer: string;
        content: string;
        footer: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<PanelStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PanelStyle>;
}
/**
 *
 * Panel is a container with the optional content toggle feature.
 *
 * [Live Demo](https://www.primeng.org/panel/)
 *
 * @module panelstyle
 *
 */
export declare enum PanelClasses {
    /**
     * Class name of the root element
     */
    root = "p-panel",
    /**
     * Class name of the header element
     */
    header = "p-panel-header",
    /**
     * Class name of the title element
     */
    title = "p-panel-title",
    /**
     * Class name of the header actions element
     */
    headerActions = "p-panel-header-actions",
    /**
     * Class name of the toggle button element
     */
    pcToggleButton = "p-panel-toggle-button",
    /**
     * Class name of the content container element
     */
    contentContainer = "p-panel-content-container",
    /**
     * Class name of the content element
     */
    content = "p-panel-content",
    /**
     * Class name of the footer element
     */
    footer = "p-panel-footer"
}
