import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class PanelMenuStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
        panel: string;
        header: ({ instance, item }: {
            instance: any;
            item: any;
        }) => (string | {
            'p-panelmenu-header-active': boolean;
            'p-disabled': any;
        })[];
        headerContent: string;
        headerLink: string;
        headerIcon: string;
        headerLabel: string;
        contentContainer: string;
        content: string;
        rootList: string;
        item: ({ instance, processedItem }: {
            instance: any;
            processedItem: any;
        }) => (string | {
            'p-focus': any;
            'p-disabled': any;
        })[];
        itemContent: string;
        itemLink: string;
        itemIcon: string;
        itemLabel: string;
        submenuIcon: string;
        submenu: string;
        separator: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<PanelMenuStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PanelMenuStyle>;
}
/**
 *
 * PanelMenu is a hybrid of Accordion and Tree components.
 *
 * [Live Demo](https://www.primeng.org/panelmenu/)
 *
 * @module panelmenustyle
 *
 */
export declare enum PanelMenuClasses {
    /**
     * Class name of the root element
     */
    root = "p-panelmenu",
    /**
     * Class name of the panel element
     */
    panel = "p-panelmenu-panel",
    /**
     * Class name of the header element
     */
    header = "p-panelmenu-header",
    /**
     * Class name of the header content element
     */
    headerContent = "p-panelmenu-header-content",
    /**
     * Class name of the header link element
     */
    headerLink = "p-panelmenu-header-link",
    /**
     * Class name of the header icon element
     */
    headerIcon = "p-panelmenu-header-icon",
    /**
     * Class name of the header label element
     */
    headerLabel = "p-panelmenu-header-label",
    /**
     * Class name of the content container element
     */
    contentContainer = "p-panelmenu-content-container",
    /**
     * Class name of the content element
     */
    content = "p-panelmenu-content",
    /**
     * Class name of the root list element
     */
    rootList = "p-panelmenu-root-list",
    /**
     * Class name of the item element
     */
    item = "p-panelmenu-item",
    /**
     * Class name of the item content element
     */
    itemContent = "p-panelmenu-item-content",
    /**
     * Class name of the item link element
     */
    itemLink = "p-panelmenu-item-link",
    /**
     * Class name of the item icon element
     */
    itemIcon = "p-panelmenu-item-icon",
    /**
     * Class name of the item label element
     */
    itemLabel = "p-panelmenu-item-label",
    /**
     * Class name of the submenu icon element
     */
    submenuIcon = "p-panelmenu-submenu-icon",
    /**
     * Class name of the submenu element
     */
    submenu = "p-panelmenu-submenu",
    separator = "p-menuitem-separator"
}
export interface PanelMenuStyle extends BaseStyle {
}
