import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class PasswordStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => {
            'p-password p-component p-inputwrapper': boolean;
            'p-inputwrapper-filled': any;
            'p-inputwrapper-focus': any;
            'p-password-fluid': any;
        };
        pcInput: string;
        maskIcon: string;
        unmaskIcon: string;
        overlay: string;
        content: string;
        meter: string;
        meterLabel: ({ instance }: {
            instance: any;
        }) => string;
        meterText: string;
    };
    inlineStyles: {
        root: ({ instance }: {
            instance: any;
        }) => {
            position: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<PasswordStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PasswordStyle>;
}
/**
 *
 * Password displays strength indicator for password fields.
 *
 * [Live Demo](https://www.primeng.org/password/)
 *
 * @module passwordstyle
 *
 */
export declare enum PasswordClasses {
    /**
     * Class name of the root element
     */
    root = "p-password",
    /**
     * Class name of the pt input element
     */
    pcInput = "p-password-input",
    /**
     * Class name of the mask icon element
     */
    maskIcon = "p-password-mask-icon",
    /**
     * Class name of the unmask icon element
     */
    unmaskIcon = "p-password-unmask-icon",
    /**
     * Class name of the overlay element
     */
    overlay = "p-password-overlay",
    /**
     * Class name of the meter element
     */
    meter = "p-password-meter",
    /**
     * Class name of the meter label element
     */
    meterLabel = "p-password-meter-label",
    /**
     * Class name of the meter text element
     */
    meterText = "p-password-meter-text"
}
export interface PasswordStyle extends BaseStyle {
}
