import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class PickListStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
        sourceControls: string;
        sourceListContainer: string;
        transferControls: string;
        targetListContainer: string;
        targetControls: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<PickListStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PickListStyle>;
}
/**
 *
 * PickList is used to reorder items between different lists.
 *
 * [Live Demo](https://www.primeng.org/picklist)
 *
 * @module pickliststyle
 *
 */
export declare enum PickListClasses {
    /**
     * Class name of the root element
     */
    root = "p-picklist",
    /**
     * Class name of the source controls element
     */
    sourceControls = "p-picklist-source-controls",
    /**
     * Class name of the source list container element
     */
    sourceListContainer = "p-picklist-source-list-container",
    /**
     * Class name of the transfer controls element
     */
    transferControls = "p-picklist-transfer-controls",
    /**
     * Class name of the target list container element
     */
    targetListContainer = "p-picklist-target-list-container",
    /**
     * Class name of the target controls element
     */
    targetControls = "p-picklist-target-controls"
}
export interface PickListStyle extends BaseStyle {
}
