import { AfterContentInit, QueryList, TemplateRef } from '@angular/core';
import { PrimeTemplate } from 'primeng/api';
import { BaseComponent } from 'primeng/basecomponent';
import { ProgressBarStyle } from './style/progressbarstyle';
import * as i0 from "@angular/core";
import * as i1 from "primeng/api";
/**
 * ProgressBar is a process status indicator.
 * @group Components
 */
export declare class ProgressBar extends BaseComponent implements AfterContentInit {
    /**
     * Current value of the progress.
     * @group Props
     */
    value: number | undefined;
    /**
     * Whether to display the progress bar value.
     * @group Props
     */
    showValue: boolean;
    /**
     * Style class of the element.
     * @group Props
     */
    styleClass: string | undefined;
    /**
     * Style class of the value element.
     * @group Props
     */
    valueStyleClass: string | undefined;
    /**
     * Inline style of the element.
     * @group Props
     */
    style: {
        [klass: string]: any;
    } | null | undefined;
    /**
     * Unit sign appended to the value.
     * @group Props
     */
    unit: string;
    /**
     * Defines the mode of the progress
     * @group Props
     */
    mode: string;
    /**
     * Color for the background of the progress.
     * @group Props
     */
    color: string | undefined;
    /**
     * Template of the content.
     * @group templates
     */
    contentTemplate: TemplateRef<any> | undefined;
    _componentStyle: ProgressBarStyle;
    templates: QueryList<PrimeTemplate> | undefined;
    _contentTemplate: TemplateRef<any> | undefined;
    ngAfterContentInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ProgressBar, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ProgressBar, "p-progressBar, p-progressbar, p-progress-bar", never, { "value": { "alias": "value"; "required": false; }; "showValue": { "alias": "showValue"; "required": false; }; "styleClass": { "alias": "styleClass"; "required": false; }; "valueStyleClass": { "alias": "valueStyleClass"; "required": false; }; "style": { "alias": "style"; "required": false; }; "unit": { "alias": "unit"; "required": false; }; "mode": { "alias": "mode"; "required": false; }; "color": { "alias": "color"; "required": false; }; }, {}, ["contentTemplate", "templates"], never, true, never>;
    static ngAcceptInputType_value: unknown;
    static ngAcceptInputType_showValue: unknown;
}
export declare class ProgressBarModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<ProgressBarModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<ProgressBarModule, never, [typeof ProgressBar, typeof i1.SharedModule], [typeof ProgressBar, typeof i1.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<ProgressBarModule>;
}
