import { BaseComponent } from 'primeng/basecomponent';
import { ProgressSpinnerStyle } from './style/progressspinnerstyle';
import * as i0 from "@angular/core";
import * as i1 from "primeng/api";
/**
 * ProgressSpinner is a process status indicator.
 * @group Components
 */
export declare class ProgressSpinner extends BaseComponent {
    /**
     * Class of the element.
     * @group Props
     */
    styleClass: string | undefined;
    /**
     * Inline style of the element.
     * @group Props
     */
    style: {
        [klass: string]: any;
    } | null | undefined;
    /**
     * Width of the circle stroke.
     * @group Props
     */
    strokeWidth: string;
    /**
     * Color for the background of the circle.
     * @group Props
     */
    fill: string;
    /**
     * Duration of the rotate animation.
     * @group Props
     */
    animationDuration: string;
    /**
     * Used to define a aria label attribute the current element.
     * @group Props
     */
    ariaLabel: string | undefined;
    _componentStyle: ProgressSpinnerStyle;
    static ɵfac: i0.ɵɵFactoryDeclaration<ProgressSpinner, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ProgressSpinner, "p-progressSpinner, p-progress-spinner, p-progressspinner", never, { "styleClass": { "alias": "styleClass"; "required": false; }; "style": { "alias": "style"; "required": false; }; "strokeWidth": { "alias": "strokeWidth"; "required": false; }; "fill": { "alias": "fill"; "required": false; }; "animationDuration": { "alias": "animationDuration"; "required": false; }; "ariaLabel": { "alias": "ariaLabel"; "required": false; }; }, {}, never, never, true, never>;
}
export declare class ProgressSpinnerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<ProgressSpinnerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<ProgressSpinnerModule, never, [typeof ProgressSpinner, typeof i1.SharedModule], [typeof ProgressSpinner, typeof i1.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<ProgressSpinnerModule>;
}
