import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class RadioButtonStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance, props }: {
            instance: any;
            props: any;
        }) => (string | {
            'p-radiobutton-checked': any;
            'p-disabled': any;
            'p-invalid': any;
            'p-variant-filled': boolean;
        })[];
        box: string;
        input: string;
        icon: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<RadioButtonStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<RadioButtonStyle>;
}
/**
 *
 * RadioButton is an extension to standard radio button element with theming.
 *
 * [Live Demo](https://www.primeng.org/radiobutton/)
 *
 * @module radiobuttonstyle
 *
 */
export declare enum RadioButtonClasses {
    /**
     * Class name of the root element
     */
    root = "p-radiobutton",
    /**
     * Class name of the box element
     */
    box = "p-radiobutton-box",
    /**
     * Class name of the input element
     */
    input = "p-radiobutton-input",
    /**
     * Class name of the icon element
     */
    icon = "p-radiobutton-icon"
}
export interface RadioButtonStyle extends BaseStyle {
}
