import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class RatingStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-readonly': any;
            'p-disabled': any;
        })[];
        option: ({ instance, props, value }: {
            instance: any;
            props: any;
            value: any;
        }) => (string | {
            'p-rating-option-active': boolean;
            'p-focus-visible': any;
        })[];
        onIcon: string;
        offIcon: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<RatingStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<RatingStyle>;
}
/**
 *
 * Rating component is a star based selection input.
 *
 * [Live Demo](https://www.primeng.org/rating/)
 *
 * @module ratingstyle
 *
 */
export declare enum RatingClasses {
    /**
     * Class name of the root element
     */
    root = "p-rating",
    /**
     * Class name of the option element
     */
    option = "p-rating-option",
    /**
     * Class name of the on icon element
     */
    onIcon = "p-rating-on-icon",
    /**
     * Class name of the off icon element
     */
    offIcon = "p-rating-off-icon"
}
export interface RatingStyle extends BaseStyle {
}
