import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ScrollerStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    static ɵfac: i0.ɵɵFactoryDeclaration<ScrollerStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ScrollerStyle>;
}
/**
 *
 * VirtualScroller is a performant approach to handle huge data efficiently.
 *
 * [Live Demo](https://www.primeng.org/scroller/)
 *
 * @module scrollerstyle
 *
 */
export declare enum ScrollerClasses {
    /**
     * Class name of the root element
     */
    root = "p-virtualscroller",
    /**
     * Class name of the content element
     */
    content = "p-virtualscroller-content",
    /**
     * Class name of the spacer element
     */
    spacer = "p-virtualscroller-spacer",
    /**
     * Class name of the loader element
     */
    loader = "p-virtualscroller-loader",
    /**
     * Class name of the loading icon element
     */
    loadingIcon = "p-virtualscroller-loading-icon"
}
export interface ScrollerStyle extends BaseStyle {
}
