import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ScrollPanelStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
        contentContainer: string;
        content: string;
        barX: string;
        barY: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ScrollPanelStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ScrollPanelStyle>;
}
/**
 *
 * ScrollPanel is a cross browser, lightweight and themable alternative to native browser scrollbar.
 *
 * [Live Demo](https://www.primeng.org/scrollpanel/)
 *
 * @module scrollpanelstyle
 *
 */
export declare enum ScrollPanelClasses {
    /**
     * Class name of the root element
     */
    root = "p-scrollpanel",
    /**
     * Class name of the content container element
     */
    contentContainer = "p-scrollpanel-content-container",
    /**
     * Class name of the content element
     */
    content = "p-scrollpanel-content",
    /**
     * Class name of the bar x element
     */
    barX = "p-scrollpanel-bar-x",
    /**
     * Class name of the bar y element
     */
    barY = "p-scrollpanel-bar-y"
}
export interface ScrollPanelStyle extends BaseStyle {
}
