import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ScrollTopStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-scrolltop-sticky': boolean;
        })[];
        icon: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ScrollTopStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ScrollTopStyle>;
}
/**
 *
 * ScrollTop gets displayed after a certain scroll position and used to navigates to the top of the page quickly.
 *
 * [Live Demo](https://www.primeng.org/scrolltop/)
 *
 * @module scrolltopstyle
 *
 */
export declare enum ScrollTopClasses {
    /**
     * Class name of the root element
     */
    root = "p-scrolltop",
    /**
     * Class name of the icon element
     */
    icon = "p-scrolltop-icon"
}
export interface ScrollTopStyle extends BaseStyle {
}
