import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class SelectStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-disabled': any;
            'p-variant-filled': boolean;
            'p-focus': any;
            'p-inputwrapper-filled': boolean;
            'p-inputwrapper-focus': any;
            'p-select-open': any;
            'p-select-fluid': any;
            'p-select-sm p-inputfield-sm': boolean;
            'p-select-lg p-inputfield-lg': boolean;
        })[];
        label: ({ instance, props }: {
            instance: any;
            props: any;
        }) => (string | {
            'p-placeholder': boolean;
            'p-select-label-empty': boolean;
        })[];
        clearIcon: string;
        dropdown: string;
        loadingicon: string;
        dropdownIcon: string;
        overlay: string;
        header: string;
        pcFilter: string;
        listContainer: string;
        list: string;
        optionGroup: string;
        optionGroupLabel: string;
        option: ({ instance, props, state, option, focusedOption }: {
            instance: any;
            props: any;
            state: any;
            option: any;
            focusedOption: any;
        }) => (string | {
            'p-select-option-selected': any;
            'p-focus': boolean;
            'p-disabled': any;
        })[];
        optionLabel: string;
        optionCheckIcon: string;
        optionBlankIcon: string;
        emptyMessage: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SelectStyle>;
}
/**
 *
 * Select also known as Select, is used to choose an item from a collection of options.
 *
 * [Live Demo](https://www.primeng.org/select/)
 *
 * @module selectstyle
 *
 */
export declare enum SelectClasses {
    /**
     * Class name of the root element
     */
    root = "p-select",
    /**
     * Class name of the label element
     */
    label = "p-select-label",
    /**
     * Class name of the clear icon element
     */
    clearIcon = "p-select-clear-icon",
    /**
     * Class name of the dropdown element
     */
    dropdown = "p-select-dropdown",
    /**
     * Class name of the loadingicon element
     */
    loadingicon = "p-select-loading-icon",
    /**
     * Class name of the dropdown icon element
     */
    dropdownIcon = "p-select-dropdown-icon",
    /**
     * Class name of the overlay element
     */
    overlay = "p-select-overlay",
    /**
     * Class name of the header element
     */
    header = "p-select-header",
    /**
     * Class name of the filter element
     */
    pcFilter = "p-select-filter",
    /**
     * Class name of the list container element
     */
    listContainer = "p-select-list-container",
    /**
     * Class name of the list element
     */
    list = "p-select-list",
    /**
     * Class name of the option group element
     */
    optionGroup = "p-select-option-group",
    /**
     * Class name of the option group label element
     */
    optionGroupLabel = "p-select-option-group-label",
    /**
     * Class name of the option element
     */
    option = "p-select-option",
    /**
     * Class name of the option label element
     */
    optionLabel = "p-select-option-label",
    /**
     * Class name of the option check icon element
     */
    optionCheckIcon = "p-select-option-check-icon",
    /**
     * Class name of the option blank icon element
     */
    optionBlankIcon = "p-select-option-blank-icon",
    /**
     * Class name of the empty message element
     */
    emptyMessage = "p-select-empty-message"
}
export interface SelectStyle extends BaseStyle {
}
