import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class SliderStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-disabled': any;
            'p-slider-horizontal': boolean;
            'p-slider-vertical': boolean;
        })[];
        range: string;
        handle: string;
    };
    inlineStyles: {
        handle: {
            position: string;
        };
        range: {
            position: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<SliderStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SliderStyle>;
}
/**
 *
 * Slider is a component to provide input with a drag handle.
 *
 * [Live Demo](https://www.primeng.org/slider/)
 *
 * @module sliderstyle
 *
 */
export declare enum SliderClasses {
    /**
     * Class name of the root element
     */
    root = "p-slider",
    /**
     * Class name of the range element
     */
    range = "p-slider-range",
    /**
     * Class name of the handle element
     */
    handle = "p-slider-handle"
}
export interface SliderStyle extends BaseStyle {
}
