import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class SpeedDialStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance, props }: {
            instance: any;
            props: any;
        }) => (string | {
            [x: string]: any;
            'p-speeddial-open': any;
            'p-disabled': any;
        })[];
        pcButton: ({ props }: {
            props: any;
        }) => (string | {
            'p-speeddial-rotate': boolean;
        })[];
        list: string;
        item: string;
        action: string;
        actionIcon: string;
        mask: ({ instance }: {
            instance: any;
        }) => (string | {
            'p-speeddial-mask-visible': any;
        })[];
    };
    inlineStyles: {
        root: ({ props }: {
            props: any;
        }) => {
            alignItems: string;
            justifyContent: string;
            flexDirection: string;
        };
        list: ({ props }: {
            props: any;
        }) => {
            flexDirection: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<SpeedDialStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SpeedDialStyle>;
}
/**
 *
 * When pressed, a floating action button can display multiple primary actions that can be performed on a page.
 *
 * [Live Demo](https://www.primeng.org/speeddial/)
 *
 * @module speeddialstyle
 *
 */
export declare enum SpeedDialClasses {
    /**
     * Class name of the root element
     */
    root = "p-speeddial",
    /**
     * Class name of the button element
     */
    pcButton = "p-speeddial-button",
    /**
     * Class name of the list element
     */
    list = "p-speeddial-list",
    /**
     * Class name of the item element
     */
    item = "p-speeddial-item",
    /**
     * Class name of the action element
     */
    action = "p-speeddial-action",
    /**
     * Class name of the action icon element
     */
    actionIcon = "p-speeddial-action-icon",
    /**
     * Class name of the mask element
     */
    mask = "p-speeddial-mask"
}
export interface SpeedDialStyle extends BaseStyle {
}
