import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class SplitButtonStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-splitbutton-raised': any;
            'p-splitbutton-rounded': any;
            'p-splitbutton-fluid': any;
        })[];
        pcButton: string;
        pcDropdown: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<SplitButtonStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SplitButtonStyle>;
}
/**
 *
 * SplitButton groups a set of commands in an overlay with a default command.
 *
 * [Live Demo](https://www.primeng.org/splitbutton/)
 *
 * @module splitbuttonstyle
 *
 */
export declare enum SplitButtonClasses {
    /**
     * Class name of the root element
     */
    root = "p-splitbutton",
    /**
     * Class name of the button element
     */
    pcButton = "p-splitbutton-button",
    /**
     * Class name of the dropdown element
     */
    pcDropdown = "p-splitbutton-dropdown"
}
export interface SplitButtonStyle extends BaseStyle {
}
