import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class SplitterStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => string[];
        gutter: string;
        gutterHandle: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<SplitterStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SplitterStyle>;
}
/**
 *
 * Splitter is utilized to separate and resize panels.
 *
 * [Live Demo](https://www.primeng.org/splitter/)
 *
 * @module splitterstyle
 *
 */
export declare enum SplitterClasses {
    /**
     * Class name of the root element
     */
    root = "p-splitter",
    /**
     * Class name of the gutter element
     */
    gutter = "p-splitter-gutter",
    /**
     * Class name of the gutter handle element
     */
    gutterHandle = "p-splitter-gutter-handle"
}
export interface SplitterStyle extends BaseStyle {
}
