import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class StepsStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-readonly': any;
        })[];
        list: string;
        item: ({ instance, item, index }: {
            instance: any;
            item: any;
            index: any;
        }) => (string | {
            'p-steps-item-active': any;
            'p-disabled': any;
        })[];
        itemLink: string;
        itemNumber: string;
        itemLabel: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<StepsStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<StepsStyle>;
}
/**
 *
 * Steps components is an indicator for the steps in a wizard workflow. Example below uses nested routes with Steps.
 *
 * [Live Demo](https://www.primeng.org/steps/)
 *
 * @module stepsstyle
 *
 */
export declare enum StepsClasses {
    /**
     * Class name of the root element
     */
    root = "p-steps",
    /**
     * Class name of the list element
     */
    list = "p-steps-list",
    /**
     * Class name of the item element
     */
    item = "p-steps-item",
    /**
     * Class name of the item link element
     */
    itemLink = "p-steps-item-link",
    /**
     * Class name of the item number element
     */
    itemNumber = "p-steps-item-number",
    /**
     * Class name of the item label element
     */
    itemLabel = "p-steps-item-label"
}
export interface StepsStyle extends BaseStyle {
}
