import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class TagStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => (string | {
            'p-tag-info': boolean;
            'p-tag-success': boolean;
            'p-tag-warn': boolean;
            'p-tag-danger': boolean;
            'p-tag-secondary': boolean;
            'p-tag-contrast': boolean;
            'p-tag-rounded': any;
        })[];
        icon: string;
        label: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<TagStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TagStyle>;
}
/**
 *
 * Tag component is used to categorize content.
 *
 * [Live Demo](https://www.primeng.org/tag)
 *
 * @module tagstyle
 *
 */
export declare enum TagClasses {
    /**
     * Class name of the root element
     */
    root = "p-tag",
    /**
     * Class name of the icon element
     */
    icon = "p-tag-icon",
    /**
     * Class name of the label element
     */
    label = "p-tag-label"
}
export interface TagStyle extends BaseStyle {
}
