import { AfterContentInit, QueryList, TemplateRef } from '@angular/core';
import { PrimeTemplate } from 'primeng/api';
import { BaseComponent } from 'primeng/basecomponent';
import { TagStyle } from './style/tagstyle';
import * as i0 from "@angular/core";
import * as i1 from "primeng/api";
/**
 * Tag component is used to categorize content.
 * @group Components
 */
export declare class Tag extends BaseComponent implements AfterContentInit {
    /**
     * Inline style of the component.
     * @group Props
     */
    get style(): {
        [klass: string]: any;
    } | null | undefined;
    set style(value: {
        [klass: string]: any;
    } | null | undefined);
    /**
     * Style class of the component.
     * @group Props
     */
    styleClass: string | undefined;
    /**
     * Severity type of the tag.
     * @group Props
     */
    severity: 'success' | 'secondary' | 'info' | 'warn' | 'danger' | 'contrast' | undefined;
    /**
     * Value to display inside the tag.
     * @group Props
     */
    value: string | undefined;
    /**
     * Icon of the tag to display next to the value.
     * @group Props
     * @deprecated since 15.4.2. Use 'icon' template.
     */
    icon: string | undefined;
    /**
     * Whether the corners of the tag are rounded.
     * @group Props
     */
    rounded: boolean | undefined;
    iconTemplate: TemplateRef<any>;
    templates: QueryList<PrimeTemplate> | undefined;
    _iconTemplate: TemplateRef<any> | undefined;
    _style: {
        [klass: string]: any;
    } | null | undefined;
    _componentStyle: TagStyle;
    ngAfterContentInit(): void;
    containerClass(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<Tag, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<Tag, "p-tag", never, { "style": { "alias": "style"; "required": false; }; "styleClass": { "alias": "styleClass"; "required": false; }; "severity": { "alias": "severity"; "required": false; }; "value": { "alias": "value"; "required": false; }; "icon": { "alias": "icon"; "required": false; }; "rounded": { "alias": "rounded"; "required": false; }; }, {}, ["iconTemplate", "templates"], ["*"], true, never>;
    static ngAcceptInputType_rounded: unknown;
}
export declare class TagModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<TagModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<TagModule, never, [typeof Tag, typeof i1.SharedModule], [typeof Tag, typeof i1.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<TagModule>;
}
