import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class TimelineStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ props }: {
            props: any;
        }) => string[];
        event: string;
        eventOpposite: string;
        eventSeparator: string;
        eventMarker: string;
        eventConnector: string;
        eventContent: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<TimelineStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TimelineStyle>;
}
/**
 *
 * Timeline visualizes a series of chained events.
 *
 * [Live Demo](https://primeng.org/timeline)
 *
 * @module timelinestyle
 *
 */
export declare enum TimelineClasses {
    /**
     * Class name of the root element
     */
    root = "p-timeline",
    /**
     * Class name of the event element
     */
    event = "p-timeline-event",
    /**
     * Class name of the event opposite element
     */
    eventOpposite = "p-timeline-event-opposite",
    /**
     * Class name of the event separator element
     */
    eventSeparator = "p-timeline-event-separator",
    /**
     * Class name of the event marker element
     */
    eventMarker = "p-timeline-event-marker",
    /**
     * Class name of the event connector element
     */
    eventConnector = "p-timeline-event-connector",
    /**
     * Class name of the event content element
     */
    eventContent = "p-timeline-event-content"
}
export interface TimelineStyle extends BaseStyle {
}
