import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ToggleButtonStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => {
            'p-togglebutton p-component': boolean;
            'p-togglebutton-checked': any;
            'p-disabled': any;
            'p-togglebutton-sm p-inputfield-sm': boolean;
            'p-togglebutton-lg p-inputfield-lg': boolean;
        };
        content: string;
        icon: string;
        label: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ToggleButtonStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ToggleButtonStyle>;
}
/**
 *
 * ToggleButton is used to select a boolean value using a button.
 *
 * [Live Demo](https://www.primeng.org/togglebutton/)
 *
 * @module togglebuttonstyle
 *
 */
export declare enum ToggleButtonClasses {
    /**
     * Class name of the root element
     */
    root = "p-togglebutton",
    /**
     * Class name of the icon element
     */
    icon = "p-togglebutton-icon",
    /**
     * Class name of the label element
     */
    label = "p-togglebutton-label"
}
export interface ToggleButtonStyle extends BaseStyle {
}
