import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ToggleSwitchStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => {
            'p-toggleswitch p-component': boolean;
            'p-toggleswitch-checked': any;
            'p-disabled': any;
            'p-invalid': any;
        };
        input: string;
        slider: string;
        handle: string;
    };
    inlineStyles: {
        root: {
            position: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ToggleSwitchStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ToggleSwitchStyle>;
}
/**
 *
 * ToggleSwitch is used to select a boolean value.
 *
 * [Live Demo](https://www.primeng.org/toggleswitch/)
 *
 * @module toggleswitchstyle
 *
 */
export declare enum ToggleSwitchClasses {
    /**
     * Class name of the root element
     */
    root = "p-toggleswitch",
    /**
     * Class name of the input element
     */
    input = "p-toggleswitch-input",
    /**
     * Class name of the slider element
     */
    slider = "p-toggleswitch-slider"
}
export interface ToggleSwitchStyle extends BaseStyle {
}
