import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class ToolbarStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
        start: string;
        center: string;
        end: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<ToolbarStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ToolbarStyle>;
}
/**
 *
 * Toolbar is a grouping component for buttons and other content.
 *
 * [Live Demo](https://www.primeng.org/toolbar/)
 *
 * @module toolbarstyle
 *
 */
export declare enum ToolbarClasses {
    /**
     * Class name of the root element
     */
    root = "p-toolbar",
    /**
     * Class name of the start element
     */
    start = "p-toolbar-start",
    /**
     * Class name of the center element
     */
    center = "p-toolbar-center",
    /**
     * Class name of the end element
     */
    end = "p-toolbar-end"
}
export interface ToolbarStyle extends BaseStyle {
}
