import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class TooltipStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: string;
        arrow: string;
        text: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<TooltipStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TooltipStyle>;
}
/**
 *
 * Tooltip directive provides advisory information for a component.
 *
 * [Live Demo](https://www.primeng.org/tooltip)
 *
 * @module tooltipstyle
 *
 */
export declare enum TooltipClasses {
    /**
     * Class name of the root element
     */
    root = "p-tooltip",
    /**
     * Class name of the arrow element
     */
    arrow = "p-tooltip-arrow",
    /**
     * Class name of the text element
     */
    text = "p-tooltip-text"
}
export interface TooltipStyle extends BaseStyle {
}
