import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class TreeSelectStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => {
            'p-treeselect p-component p-inputwrapper': boolean;
            'p-treeselect-display-chip': boolean;
            'p-disabled': any;
            'p-invalid': any;
            'p-focus': any;
            'p-variant-filled': boolean;
            'p-inputwrapper-filled': boolean;
            'p-inputwrapper-focus': any;
            'p-treeselect-open': any;
            'p-treeselect-clearable': any;
            'p-treeselect-fluid': any;
            'p-treeselect-sm p-inputfield-sm': boolean;
            'p-treeselect-lg p-inputfield-lg': boolean;
        };
        labelContainer: string;
        label: ({ instance }: {
            instance: any;
        }) => {
            'p-treeselect-label': boolean;
            'p-placeholder': boolean;
            'p-treeselect-label-empty': any;
        };
        chip: string;
        pcChip: string;
        dropdown: string;
        dropdownIcon: string;
        panel: string;
        treeContainer: string;
        emptyMessage: string;
    };
    inlineStyles: {
        root: ({ instance }: {
            instance: any;
        }) => {
            position: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<TreeSelectStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TreeSelectStyle>;
}
/**
 *
 * TreeSelect is a form component to choose from hierarchical data.
 *
 * [Live Demo](https://www.primeng.org/treeselect/)
 *
 * @module treeselectstyle
 *
 */
export declare enum TreeSelectClasses {
    /**
     * Class name of the root element
     */
    root = "p-treeselect",
    /**
     * Class name of the label container element
     */
    labelContainer = "p-treeselect-label-container",
    /**
     * Class name of the label element
     */
    label = "p-treeselect-label",
    /**
     * Class name of the chip item element
     */
    chipItem = "p-treeselect-chip-item",
    /**
     * Class name of the chip element
     */
    pcChip = "p-treeselect-chip",
    /**
     * Class name of the dropdown element
     */
    dropdown = "p-treeselect-dropdown",
    /**
     * Class name of the dropdown icon element
     */
    dropdownIcon = "p-treeselect-dropdown-icon",
    /**
     * Class name of the panel element
     */
    panel = "p-treeselect-overlay",
    /**
     * Class name of the tree container element
     */
    treeContainer = "p-treeselect-tree-container",
    /**
     * Class name of the empty message element
     */
    emptyMessage = "p-treeselect-empty-message"
}
export interface TreeSelectStyle extends BaseStyle {
}
