import { BaseStyle } from 'primeng/base';
import * as i0 from "@angular/core";
export declare class TreeTableStyle extends BaseStyle {
    name: string;
    theme: ({ dt }: {
        dt: any;
    }) => string;
    classes: {
        root: ({ instance }: {
            instance: any;
        }) => {
            'p-treetable p-component': boolean;
            'p-treetable-hoverable': any;
            'p-treetable-resizable': any;
            'p-treetable-resizable-fit': boolean;
            'p-treetable-scrollable': any;
            'p-treetable-flex-scrollable': boolean;
            'p-treetable-gridlines': any;
            'p-treetable-sm': boolean;
            'p-treetable-lg': boolean;
        };
        loading: string;
        mask: string;
        loadingIcon: string;
        header: string;
        paginator: ({ instance }: {
            instance: any;
        }) => string;
        tableContainer: string;
        table: ({ instance }: {
            instance: any;
        }) => {
            'p-treetable-table': boolean;
            'p-treetable-scrollable-table': any;
            'p-treetable-resizable-table': any;
            'p-treetable-resizable-table-fit': boolean;
        };
        thead: string;
        headerCell: ({ instance }: {
            instance: any;
        }) => {
            'p-treetable-header-cell': boolean;
            'p-treetable-sortable-column': any;
            'p-treetable-resizable-column': any;
            'p-treetable-column-sorted': any;
            'p-treetable-frozen-column': any;
        };
        columnResizer: string;
        columnHeaderContent: string;
        columnTitle: string;
        sortIcon: string;
        pcSortBadge: string;
        tbody: string;
        row: ({ instance }: {
            instance: any;
        }) => {
            'p-treetable-row-selected': any;
        };
        bodyCell: ({ instance }: {
            instance: any;
        }) => {
            'p-treetable-frozen-column': any;
        };
        bodyCellContent: ({ instance }: {
            instance: any;
        }) => {
            'p-treetable-body-cell-content': boolean;
            'p-treetable-body-cell-content-expander': any;
        };
        toggler: string;
        nodeToggleButton: string;
        nodeToggleIcon: string;
        pcNodeCheckbox: string;
        emptyMessage: string;
        tfoot: string;
        footerCell: ({ instance }: {
            instance: any;
        }) => {
            'p-treetable-frozen-column': any;
        };
        footer: string;
        columnResizeIndicator: string;
    };
    inlineStyles: {
        tableContainer: {
            overflow: string;
        };
        thead: {
            position: string;
        };
        tfoot: {
            position: string;
        };
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<TreeTableStyle, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TreeTableStyle>;
}
/**
 *
 * TreeTable is used to display hierarchical data in tabular format.
 *
 * [Live Demo](https://www.primeng.org/treetable/)
 *
 * @module treetablestyle
 *
 */
export declare enum TreeTableClasses {
    /**
     * Class name of the root element
     */
    root = "p-treetable",
    /**
     * Class name of the loading element
     */
    loading = "p-treetable-loading",
    /**
     * Class name of the mask element
     */
    mask = "p-treetable-mask",
    /**
     * Class name of the loading icon element
     */
    loadingIcon = "p-treetable-loading-icon",
    /**
     * Class name of the header element
     */
    header = "p-treetable-header",
    /**
     * Class name of the paginator element
     */
    paginator = "p-treetable-paginator-[position]",
    /**
     * Class name of the table container element
     */
    tableContainer = "p-treetable-table-container",
    /**
     * Class name of the table element
     */
    table = "p-treetable-table",
    /**
     * Class name of the thead element
     */
    thead = "p-treetable-thead",
    /**
     * Class name of the column resizer element
     */
    columnResizer = "p-treetable-column-resizer",
    /**
     * Class name of the column title element
     */
    columnTitle = "p-treetable-column-title",
    /**
     * Class name of the sort icon element
     */
    sortIcon = "p-treetable-sort-icon",
    /**
     * Class name of the sort badge element
     */
    pcSortBadge = "p-treetable-sort-badge",
    /**
     * Class name of the tbody element
     */
    tbody = "p-treetable-tbody",
    /**
     * Class name of the node toggle button element
     */
    nodeToggleButton = "p-treetable-node-toggle-button",
    /**
     * Class name of the node toggle icon element
     */
    nodeToggleIcon = "p-treetable-node-toggle-icon",
    /**
     * Class name of the node checkbox element
     */
    pcNodeCheckbox = "p-treetable-node-checkbox",
    /**
     * Class name of the empty message element
     */
    emptyMessage = "p-treetable-empty-message",
    /**
     * Class name of the tfoot element
     */
    tfoot = "p-treetable-tfoot",
    /**
     * Class name of the footer element
     */
    footer = "p-treetable-footer",
    /**
     * Class name of the column resize indicator element
     */
    columnResizeIndicator = "p-treetable-column-resize-indicator"
}
export interface TreeTableStyle extends BaseStyle {
}
